## obs-source-clone 0.1.1

=== CMakeLists.txt ===
# --- Detect if the plugin is build out of tree or not ---
if(CMAKE_PROJECT_NAME STREQUAL "obs-studio")
  set(BUILD_OUT_OF_TREE OFF)
else()
  set(BUILD_OUT_OF_TREE ON)
  cmake_minimum_required(VERSION 3.18)
endif()

project(source-clone VERSION 0.1.1)
set(PROJECT_FULL_NAME "Source Clone")

# Set new UUIDs when you start to create a new plugin.
set(MACOS_PACKAGE_UUID "4D728E27-0312-47D1-8A14-73CEDA4D08F4")
set(MACOS_INSTALLER_UUID "08C20936-6B8C-4F19-8D40-2707D52FD8A9")

add_library(${PROJECT_NAME} MODULE)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.h.in ${CMAKE_CURRENT_SOURCE_DIR}/version.h)

target_sources(${PROJECT_NAME} PRIVATE
	source-clone.c
	source-clone.h
	version.h)

if(BUILD_OUT_OF_TREE)
	find_package(libobs REQUIRED)
	include(cmake/ObsPluginHelpers.cmake)
endif()
  
if(OS_WINDOWS)
	get_filename_component(ISS_FILES_DIR "${CMAKE_BINARY_DIR}\\..\\package" ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_FILES_DIR}" ISS_FILES_DIR)
	get_filename_component(ISS_PACKAGE_DIR "${CMAKE_PACKAGE_PREFIX}\\.." ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_PACKAGE_DIR}" ISS_PACKAGE_DIR)
	get_filename_component(ISS_SOURCE_DIR "${PROJECT_SOURCE_DIR}" ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_SOURCE_DIR}" ISS_SOURCE_DIR)
	configure_file("installer.iss.in"
			"${PROJECT_BINARY_DIR}/installer.iss"
		)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/resource.rc.in ${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc)
	target_sources(${PROJECT_NAME} PRIVATE 
		${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc)
	target_link_libraries(${PROJECT_NAME}
		w32-pthreads)
elseif(OS_MACOS)
		set(MACOS_BUNDLEID "com.exeldro.${PROJECT_NAME}")
		set(MACOSX_PLUGIN_GUI_IDENTIFIER "${MACOS_BUNDLEID}")
		set(MACOSX_PLUGIN_BUNDLE_VERSION "${PROJECT_VERSION}")
		set(MACOSX_PLUGIN_SHORT_VERSION_STRING "1")
		configure_file(cmake/bundle/macos/installer-macos.pkgproj.in ${CMAKE_BINARY_DIR}/installer-macos.generated.pkgproj)
		target_compile_options(${PROJECT_NAME} PRIVATE -Wall)
endif()

target_link_libraries(${PROJECT_NAME}
	OBS::libobs)

if(BUILD_OUT_OF_TREE)
    if(NOT LIB_OUT_DIR)
        set(LIB_OUT_DIR "/lib/obs-plugins")
    endif()
    if(NOT DATA_OUT_DIR)
        set(DATA_OUT_DIR "/share/obs/obs-plugins/${PROJECT_NAME}")
    endif()
    set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "")
    install(TARGETS ${PROJECT_NAME}
        LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/${LIB_OUT_DIR})
    install(DIRECTORY data/locale
        DESTINATION ${CMAKE_INSTALL_PREFIX}/${DATA_OUT_DIR})
else()
    set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "plugins/exeldro")
endif()
setup_plugin_target(${PROJECT_NAME})

=== debian/changelog ===
obs-source-clone (0.1.1-6) unstable; urgency=medium

  * debian/rules: removed temporary workaround to exclude extra installed
    files in favor of the '-DLINUX_PORTABLE=Off' argument for CMake.
  * debian/upstream/metadata: updated Donation field.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 21 Feb 2023 18:33:50 -0300

obs-source-clone (0.1.1-5) unstable; urgency=medium

  * debian/control: bumped relationships for libobs-dev and obs-studio to 29.
  * debian/rules: fixed execute_after_dh_install target.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 06 Feb 2023 11:01:51 -0300

obs-source-clone (0.1.1-4) unstable; urgency=medium

  * debian/watch: using filenamemangle to generate right names for downloaded
    files.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 31 Jan 2023 21:47:10 -0300

obs-source-clone (0.1.1-3) unstable; urgency=medium

  * debian/rules: added a target to check if translation to pt_BR is updated.
  * debian/upstream/metadata: added Screenshots field.
  * debian/watch: improved the search rule, checking if the upstream forgotten
    to add a tag on GitHub.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 30 Jan 2023 12:49:24 -0300

obs-source-clone (0.1.1-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/patches/010_add-pt-BR.patch: created to add translation to pt_BR.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 24 Jan 2023 17:27:34 -0300

obs-source-clone (0.1.1-1) experimental; urgency=medium

  * Initial release. (Closes: #1029560)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 24 Jan 2023 11:21:27 -0300

=== debian/control ===
Source: obs-source-clone
Section: video
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake, libobs-dev (>= 29)
Standards-Version: 4.6.2
Homepage: https://obsproject.com/forum/resources/source-clone.1632/
Vcs-Browser: https://salsa.debian.org/debian/obs-source-clone
Vcs-Git: https://salsa.debian.org/debian/obs-source-clone.git

Package: obs-source-clone
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, obs-studio (>= 29)
Enhances: obs-studio
Description: plugin for OBS Studio to clone sources from a scene
 This plugin lets to clone sources to allow different filters than the
 original. The main idea is generate a new source type that gets sources
 from a scene and clone them in current scene.
 .
 WARNING: Source Clone is not an async source. In OBS there are async
 sources that can have more types of filters.
 .
 To use Source Clone, click over the "plus" signal inside the Sources
 Dock.

## obs-source-clone 0.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
   cmake_minimum_required(VERSION 3.18)
 endif()
 
-project(source-clone VERSION 0.1.1)
+project(source-clone VERSION 0.1.4)
 set(PROJECT_FULL_NAME "Source Clone")
 
 # Set new UUIDs when you start to create a new plugin.
@@ -19,12 +19,18 @@
 
 target_sources(${PROJECT_NAME} PRIVATE
 	source-clone.c
+	audio-wrapper.c
 	source-clone.h
+	audio-wrapper.h
 	version.h)
 
 if(BUILD_OUT_OF_TREE)
 	find_package(libobs REQUIRED)
+	find_package(obs-frontend-api REQUIRED)
 	include(cmake/ObsPluginHelpers.cmake)
+	set(OBS_FRONTEND_API_NAME "obs-frontend-api")
+else()
+	set(OBS_FRONTEND_API_NAME "frontend-api")
 endif()
   
 if(OS_WINDOWS)
@@ -52,6 +58,7 @@
 endif()
 
 target_link_libraries(${PROJECT_NAME}
+	OBS::${OBS_FRONTEND_API_NAME}
 	OBS::libobs)
 
 if(BUILD_OUT_OF_TREE)
@@ -67,6 +74,8 @@
     install(DIRECTORY data/locale
         DESTINATION ${CMAKE_INSTALL_PREFIX}/${DATA_OUT_DIR})
 else()
+    target_include_directories(${PROJECT_NAME} PRIVATE
+        "${CMAKE_SOURCE_DIR}/UI/obs-frontend-api")
     set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "plugins/exeldro")
 endif()
 setup_plugin_target(${PROJECT_NAME})

=== debian/changelog ===
obs-source-clone (0.1.4-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 24 Jul 2023 13:02:41 -0300

obs-source-clone (0.1.4-1) unstable; urgency=medium

  * New upstream version 0.1.4.
  * debian/control: added a Breaks field to make this plugin incompatible with
    obs-text-slideshow (<= 1.5.2-3), no longer in Debian.
  * debian/copyright: updated upstream copyright years.
  * debian/patches/:
      - 010_add-pt-BR.patch: updated to be compliant with the current upstream
        release.
      - 020_add-EOF.patch: created to add an EOF to en-US translation.
  * debian/rules: using 'export DEB_CFLAGS_MAINT_APPEND = -Wno-psabi' to avoid
    a FTBFS in 32-bit archs when building with GCC-12.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 13 Jun 2023 12:59:31 -0300

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Needed for GCC-12 and ABI issues.
# https://github.com/exeldro/obs-source-clone/issues/16
export DEB_CFLAGS_MAINT_APPEND = -Wno-psabi

# Exclude "obs-" from NAME and set a DEST
export PLUGIN_NAME=$(shell echo ${DEB_SOURCE} | cut -d"-" -f2-)
export PLUGIN_DEST=debian/${DEB_SOURCE}/usr/lib/${DEB_TARGET_MULTIARCH}/obs-plugins

%:
	dh $@

execute_before_dh_auto_configure:
	if [ "$(shell hostname)" = "canopus" ]; then \
	    LINESUS=$(shell cat data/locale/en-US.ini | wc -l); \
	    LINESPT=$(shell cat data/locale/pt-BR.ini | wc -l); \
	    if [ "$$LINESUS" != "$$LINESPT" ]; then \
	        echo "ERROR: Translation to pt_BR is out of date."; \
	        exit 1; \
	    fi; \
	fi

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_OUT_OF_TREE=On \
                             -DLIB_OUT_DIR=lib/${DEB_TARGET_MULTIARCH}/obs-plugins \
                             -DDATA_OUT_DIR=share/obs/obs-plugins/${PLUGIN_NAME} \
                             -DLINUX_PORTABLE=Off

execute_after_dh_install-arch:
	# Check if the plugin is in right place
	ls ${PLUGIN_DEST}/${PLUGIN_NAME}.so

=== debian/watch ===
version=4
# The following rule is right, but the upstream frequently...
# https://github.com/exeldro/obs-source-clone/tags archive/refs/tags/(\d\S+)\.tar\.(?:bz2|gz|xz)

# The upstream frequently forgets to update the tag on GitHub, but he always
# updates the official homepage at obsproject.com (see Homepage field at
# debian/control file). The following rule is a workaround to check the current
# version on the official homepage and to call this version from the GitHub.

# LINTIAN will warn about the filenamemangle. The filenamemangle is needed
# because we are using jumps and workarounds to get the last version from the
# upstream. Consequently, the name got by uscan is an HTML code (this is trash,
# no filename, no version).

opts="searchmode=plain, \
      downloadurlmangle=s/.*u-muted..([\d\.]+).*/https:\/\/github.com\/exeldro\/@PACKAGE@\/archive\/refs\/tags\/$1\.tar\.gz/, \
      filenamemangle=s/.*muted..([\d\.]+)..span./@PACKAGE@-$1\.tar\.gz/" \
https://obsproject.com/forum/resources/source-clone.1632 .span.class..u-muted..(\d\S+)..span.

## obs-source-clone 0.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,15 @@
 # --- Detect if the plugin is build out of tree or not ---
 if(CMAKE_PROJECT_NAME STREQUAL "obs-studio")
   set(BUILD_OUT_OF_TREE OFF)
+  if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
+    legacy_check()
+  endif()
 else()
   set(BUILD_OUT_OF_TREE ON)
   cmake_minimum_required(VERSION 3.18)
 endif()
 
-project(source-clone VERSION 0.1.4)
+project(source-clone VERSION 0.1.5)
 set(PROJECT_FULL_NAME "Source Clone")
 
 # Set new UUIDs when you start to create a new plugin.
@@ -73,9 +76,14 @@
         LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/${LIB_OUT_DIR})
     install(DIRECTORY data/locale
         DESTINATION ${CMAKE_INSTALL_PREFIX}/${DATA_OUT_DIR})
+    setup_plugin_target(${PROJECT_NAME})
 else()
     target_include_directories(${PROJECT_NAME} PRIVATE
         "${CMAKE_SOURCE_DIR}/UI/obs-frontend-api")
-    set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "plugins/exeldro")
+    if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
+        set_target_properties_obs(${PROJECT_NAME} PROPERTIES FOLDER "plugins/exeldro" PREFIX "")
+    else()
+        set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "plugins/exeldro")
+        setup_plugin_target(${PROJECT_NAME})
+    endif()
 endif()
-setup_plugin_target(${PROJECT_NAME})

=== debian/changelog ===
obs-source-clone (0.1.5-1) unstable; urgency=medium

  * New upstream version 0.1.5. (Closes: #1071541)
  * debian/copyright: updated upstream and packaging copyright years.
  * debian/patches/:
      - Removed the following patches because the upstream fixed the source
        code (thanks):
          ~ 010_add-pt-BR.patch
          ~ 020_add-EOF.patch]
      - 010_update_pt-BR.patch: created to updated pt-BR translation.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 22 May 2024 12:29:45 -0300

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, obs-studio (>= 29)
 Enhances: obs-studio
+Breaks: obs-text-slideshow (<= 1.5.2-3)
 Description: plugin for OBS Studio to clone sources from a scene
  This plugin lets to clone sources to allow different filters than the
  original. The main idea is generate a new source type that gets sources

## obs-source-clone 0.2.1

=== debian/changelog ===
obs-source-clone (0.2.1-1) unstable; urgency=medium

  * New upstream version 0.2.1.
  * debian/clean: added cmake/.CMakeBuildNumber.
  * debian/control:
      - Bumped Standards-Version to 4.7.3.
      - Removed no longer needed "Priority: optional" field.
      - Removed no longer needed "Rules-Requires-Root: no" field.
      - Updated dependencies to require libobs-dev and obs-studio >= 32.
        (Closes: #1128461)
  * debian/copyright: updated upstream and packaging copyright years.
  * debian/patches/010_update_pt-BR.patch: updated translation to pt-BR.
  * debian/watch: migrated to version 5.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 22 Feb 2026 22:12:07 -0300

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,8 @@
 Source: obs-source-clone
 Section: video
-Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 13), cmake, libobs-dev (>= 29)
-Standards-Version: 4.6.2
+Build-Depends: debhelper-compat (= 13), cmake, libobs-dev (>= 32)
+Standards-Version: 4.7.3
 Homepage: https://obsproject.com/forum/resources/source-clone.1632/
 Vcs-Browser: https://salsa.debian.org/debian/obs-source-clone
 Vcs-Git: https://salsa.debian.org/debian/obs-source-clone.git
@@ -12,7 +10,7 @@
 Package: obs-source-clone
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, obs-studio (>= 29)
+Depends: ${shlibs:Depends}, ${misc:Depends}, obs-studio (>= 32)
 Enhances: obs-studio
 Breaks: obs-text-slideshow (<= 1.5.2-3)
 Description: plugin for OBS Studio to clone sources from a scene

=== debian/watch ===
Version: 5

# The following rule is right, but the upstream frequently...
# https://github.com/exeldro/obs-source-clone/tags archive/refs/tags/(\d\S+)\.tar\.(?:bz2|gz|xz)
# The upstream frequently forgets to update the tag on GitHub, but he always
# updates the official homepage at obsproject.com (see Homepage field at
# debian/control file). The following rule is a workaround to check the current
# version on the official homepage and to call this version from the GitHub.
# LINTIAN will warn about the filenamemangle. The filenamemangle is needed
# because we are using jumps and workarounds to get the last version from the
# upstream. Consequently, the name got by uscan is an HTML code (this is trash,
# no filename, no version).
Source: https://obsproject.com/forum/resources/source-clone.1632
Matching-Pattern: .span.class..u-muted..(\d\S+)..span.
Downloadurlmangle: s/.*u-muted..([\d\.]+).*/https:\/\/github.com\/exeldro\/@PACKAGE@\/archive\/refs\/tags\/$1\.tar\.gz/
Filenamemangle: s/.*muted..([\d\.]+)..span./@PACKAGE@-$1\.tar\.gz/
Searchmode: plain
